# agent.pm
  $version = "0.1.1";
# =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# homer agent library

use Getopt::Long;
use IO::Socket;

# =-= The happy variable setting part =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

$defaultconf     = "/opt/homer/etc/agent.conf";

$0 = $program if $program;


1;

# =-= Read configuration file =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

sub read_config {
  open (F, $conf) || die "Cannot open $conf: $!\n";
  CONF: foreach $line (<F>) {
    $line =~  s/^\s+//g;
    $line =~ s/\s+$//g;
    $line =~ s/#.*$//g;
    next CONF if $line eq "";
  
    if ($line =~ /\[.+\]/) {
      ($segment) = $line =~ /\[(.+)\]/;
      $count{$segment}++;
    } else {
     ($name,$value) = split(/[\s]*=\s*/,$line);
     $value =~ s/\s+$//;
     if ($segment && $name && $value) {
       $conf{$segment}[$count{$segment}-1]{$name} = $value;
     }
    }
  }
  close F; 
  %global = %{$conf{global}[0]};
}

# =-= Print version info -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

sub version {
  print "$0, version $version\n";
  print "$cr\n";
  exit;
}


package event;

sub new {
  my $class = shift;
  $event_id++;
  return bless({ id => $event_id },$class);
}

sub report {
  $self = shift;
  $string = qq|<event reporter="$self->{reporter}" class="$self->{class}" 
   severity="$self->{severity}" object="$self->{object}" 
   health="$self->{health}" description="$self->{description}" />|;

  @dispatchers = @{$main::conf{dispatcher}};

  foreach $disp (@dispatchers) {
    undef $sock;
    $host = "$disp->{address}:$disp->{port}"; 
#    print "Reporting to $host\n" if $main::verbose;
    $sock = IO::Socket::INET->new(PeerAddr => $host) || 
      die "Can't connect to dispatcher\n";
    my $buffer = <$sock>;
    if ($buffer =~ /homerd/) {
      print $sock "$string\n";
      print $sock "quit\n";
    } else {
      die "homerd did not answer!\n";
    }
    $sock->close();
  }
}



